git-merge: no reason to use cpio anymore
[git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 USAGE='[ | list | show | apply | clear]'
5
6 SUBDIRECTORY_OK=Yes
7 . git-sh-setup
8 require_work_tree
9 cd_to_toplevel
10
11 TMP="$GIT_DIR/.git-stash.$$"
12 trap 'rm -f "$TMP-*"' 0
13
14 ref_stash=refs/stash
15
16 no_changes () {
17         git diff-index --quiet --cached HEAD &&
18         git diff-files --quiet
19 }
20
21 clear_stash () {
22         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
23         then
24                 git update-ref -d refs/stash $current
25         fi
26 }
27
28 create_stash () {
29         stash_msg="$1"
30
31         if no_changes
32         then
33                 exit 0
34         fi
35
36         # state of the base commit
37         if b_commit=$(git rev-parse --verify HEAD)
38         then
39                 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
40         else
41                 die "You do not have the initial commit yet"
42         fi
43
44         if branch=$(git symbolic-ref -q HEAD)
45         then
46                 branch=${branch#refs/heads/}
47         else
48                 branch='(no branch)'
49         fi
50         msg=$(printf '%s: %s' "$branch" "$head")
51
52         # state of the index
53         i_tree=$(git write-tree) &&
54         i_commit=$(printf 'index on %s\n' "$msg" |
55                 git commit-tree $i_tree -p $b_commit) ||
56                 die "Cannot save the current index state"
57
58         # state of the working tree
59         w_tree=$( (
60                 rm -f "$TMP-index" &&
61                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
62                 GIT_INDEX_FILE="$TMP-index" &&
63                 export GIT_INDEX_FILE &&
64                 git read-tree -m $i_tree &&
65                 git add -u &&
66                 git write-tree &&
67                 rm -f "$TMP-index"
68         ) ) ||
69                 die "Cannot save the current worktree state"
70
71         # create the stash
72         if test -z "$stash_msg"
73         then
74                 stash_msg=$(printf 'WIP on %s' "$msg")
75         else
76                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
77         fi
78         w_commit=$(printf '%s\n' "$stash_msg" |
79                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
80                 die "Cannot record working tree state"
81 }
82
83 save_stash () {
84         stash_msg="$1"
85
86         if no_changes
87         then
88                 echo >&2 'No local changes to save'
89                 exit 0
90         fi
91         test -f "$GIT_DIR/logs/$ref_stash" ||
92                 clear_stash || die "Cannot initialize stash"
93
94         create_stash "$stash_msg"
95         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
96                 die "Cannot save the current status"
97         printf >&2 'Saved "%s"\n' "$stash_msg"
98 }
99
100 have_stash () {
101         git rev-parse --verify $ref_stash >/dev/null 2>&1
102 }
103
104 list_stash () {
105         have_stash || return 0
106         git log --pretty=oneline -g "$@" $ref_stash |
107         sed -n -e 's/^[.0-9a-f]* refs\///p'
108 }
109
110 show_stash () {
111         flags=$(git rev-parse --no-revs --flags "$@")
112         if test -z "$flags"
113         then
114                 flags=--stat
115         fi
116         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
117
118         w_commit=$(git rev-parse --verify "$s") &&
119         b_commit=$(git rev-parse --verify "$s^") &&
120         git diff $flags $b_commit $w_commit
121 }
122
123 apply_stash () {
124         git diff-files --quiet ||
125                 die 'Cannot restore on top of a dirty state'
126
127         unstash_index=
128         case "$1" in
129         --index)
130                 unstash_index=t
131                 shift
132         esac
133
134         # current index state
135         c_tree=$(git write-tree) ||
136                 die 'Cannot apply a stash in the middle of a merge'
137
138         # stash records the work tree, and is a merge between the
139         # base commit (first parent) and the index tree (second parent).
140         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
141         w_tree=$(git rev-parse --verify "$s:") &&
142         b_tree=$(git rev-parse --verify "$s^1:") &&
143         i_tree=$(git rev-parse --verify "$s^2:") ||
144                 die "$*: no valid stashed state found"
145
146         unstashed_index_tree=
147         if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
148         then
149                 git diff --binary $s^2^..$s^2 | git apply --cached
150                 test $? -ne 0 &&
151                         die 'Conflicts in index. Try without --index.'
152                 unstashed_index_tree=$(git-write-tree) ||
153                         die 'Could not save index tree'
154                 git reset
155         fi
156
157         eval "
158                 GITHEAD_$w_tree='Stashed changes' &&
159                 GITHEAD_$c_tree='Updated upstream' &&
160                 GITHEAD_$b_tree='Version stash was based on' &&
161                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
162         "
163
164         if git-merge-recursive $b_tree -- $c_tree $w_tree
165         then
166                 # No conflict
167                 if test -n "$unstashed_index_tree"
168                 then
169                         git read-tree "$unstashed_index_tree"
170                 else
171                         a="$TMP-added" &&
172                         git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
173                         git read-tree --reset $c_tree &&
174                         git update-index --add --stdin <"$a" ||
175                                 die "Cannot unstage modified files"
176                         rm -f "$a"
177                 fi
178                 git status || :
179         else
180                 # Merge conflict; keep the exit status from merge-recursive
181                 status=$?
182                 if test -n "$unstash_index"
183                 then
184                         echo >&2 'Index was not unstashed.'
185                 fi
186                 exit $status
187         fi
188 }
189
190 # Main command set
191 case "$1" in
192 list)
193         shift
194         if test $# = 0
195         then
196                 set x -n 10
197                 shift
198         fi
199         list_stash "$@"
200         ;;
201 show)
202         shift
203         show_stash "$@"
204         ;;
205 apply)
206         shift
207         apply_stash "$@"
208         ;;
209 clear)
210         clear_stash
211         ;;
212 create)
213         if test $# -gt 0 && test "$1" = create
214         then
215                 shift
216         fi
217         create_stash "$*" && echo "$w_commit"
218         ;;
219 help | usage)
220         usage
221         ;;
222 *)
223         if test $# -gt 0 && test "$1" = save
224         then
225                 shift
226         fi
227         save_stash "$*" && git-reset --hard
228         ;;
229 esac